"use strict";
const equal = require('equals');
class SelectAccessor {
    constructor() {
        this.selected = [];
        this._value = undefined;
    }
    get value() {
        return this.multiple ? this.selected : this.options[this._value];
    }
    ;
    set value(value) {
        this._value = value;
        this._onChangeCallback(this.value);
    }
    onTouched(value) {
        this._onTouchedCallback(value);
    }
    writeValue(value) {
        this._value = this.multiple ? this.selected : this.findIndexValue(value);
    }
    findIndexValue(value) {
        const identifyBy = this.identifyBy;
        if (identifyBy) {
            if (!value || !value.hasOwnProperty(identifyBy)) {
                return;
            }
            value = this.options.filter(item => item[identifyBy] === value[identifyBy])[0];
        }
        return this.options.findIndex(item => equal(item, value));
    }
    identify(value) {
        const identifyBy = this.identifyBy;
        return identifyBy && value ? value[identifyBy] : undefined;
    }
    registerOnChange(fn) {
        this._onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this._onTouchedCallback = fn;
    }
}
exports.SelectAccessor = SelectAccessor;
//# sourceMappingURL=accessor.js.map