"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const core_1 = require('@angular/core');
const selectable_1 = require('./decorators/selectable');
const forms_1 = require('@angular/forms');
const ng2_material_dropdown_1 = require('ng2-material-dropdown');
const accessor_1 = require('./accessor');
const CUSTOM_SELECT_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(() => Ng2Select),
    multi: true
};
let Ng2Select = class Ng2Select extends accessor_1.SelectAccessor {
    constructor() {
        super(...arguments);
        this.options = [];
        this.multiple = false;
        this.onChange = new core_1.EventEmitter();
    }
    getSelectedValue() {
        if (this.multiple && this.selected.length === 1) {
            return this.displayValue(this.selected[0]);
        }
        else {
            const index = this.options.indexOf(this.value);
            return index >= 0 ? this.displayValue(this.options[index]) : undefined;
        }
    }
    displayValue(item) {
        return this.displayBy ? item[this.displayBy] : item;
    }
    get placeholderDisplay() {
        if (this.multiple && this.selected.length > 1) {
            return `${this.selected.length} items selected`;
        }
        else {
            return this.getSelectedValue() || this.placeholder;
        }
    }
    isSelected(item) {
        if (this.multiple) {
            return this.selected.indexOf(item) >= 0;
        }
        else {
            return this.value === item;
        }
    }
    ngOnInit() {
        const state = this.dropdown.state;
        state.onItemClicked.subscribe(item => {
            if (this.multiple) {
                this.toggle(item.value);
            }
            this.value = this.multiple ? this.selected : this.options.indexOf(item.value);
            this.onChange.emit(this.value);
        });
        this.dropdown.onShow.subscribe(() => {
            if (!this.value) {
                return;
            }
            const index = this.findIndexValue(this.value);
            const item = this.dropdown.menu.items.toArray()[index];
            this.dropdown.state.select(item, false);
        });
        console.log(this.selected);
    }
};
__decorate([
    core_1.Input(), 
    __metadata('design:type', String)
], Ng2Select.prototype, "placeholder", void 0);
__decorate([
    core_1.Input(), 
    __metadata('design:type', Array)
], Ng2Select.prototype, "options", void 0);
__decorate([
    core_1.Input(), 
    __metadata('design:type', String)
], Ng2Select.prototype, "displayBy", void 0);
__decorate([
    core_1.Input(), 
    __metadata('design:type', String)
], Ng2Select.prototype, "identifyBy", void 0);
__decorate([
    core_1.Input(), 
    __metadata('design:type', Boolean)
], Ng2Select.prototype, "multiple", void 0);
__decorate([
    core_1.Output(), 
    __metadata('design:type', core_1.EventEmitter)
], Ng2Select.prototype, "onChange", void 0);
__decorate([
    core_1.ViewChild(ng2_material_dropdown_1.Ng2Dropdown), 
    __metadata('design:type', Object)
], Ng2Select.prototype, "dropdown", void 0);
Ng2Select = __decorate([
    core_1.Component({
        selector: 'ng2-select',
        providers: [CUSTOM_SELECT_VALUE_ACCESSOR],
        styles: [require('./style.scss').toString()],
        template: require('./template.html')
    }),
    selectable_1.Selectable(), 
    __metadata('design:paramtypes', [])
], Ng2Select);
exports.Ng2Select = Ng2Select;
//# sourceMappingURL=ng2-select.js.map